import RPi.GPIO as GPIO
import time

GPIO.setmode(GPIO.BCM)

GPIO.setup(19, GPIO.OUT)

def set_position(pulse_time):
        global p
        valley = 20 #time between each pulse for motor servo control (msec)
        peak = pulse_time
    
        freq = 1/((valley+peak)*0.001)
        duty = peak/(valley+peak)*100

        p.ChangeFrequency(freq)
        p.ChangeDutyCycle(duty)

p = GPIO.PWM(19, 47)
p.start(0)

set_position(1)

try:
	while True:
		percentage = input('enter percentage (rounded to nearest 10) to dispense: ')
		pos = .7
		percentage = percentage - 6
		set_position(.7)
		if percentage > 0:
			time.sleep(.066*percentage)
		
		while(pos < 1):
			pos += .05
			set_position(pos)
			time.sleep(.15)
		set_position(0)		
					
except KeyboardInterrupt:
	p.stop()
	GPIO.cleanup()
	quit()
