from Tkinter import *
import RPi.GPIO as GPIO
import time

# set up gui

class App:
	
	def __init__(self,master):
		
		frame = Frame(master)
		frame.pack()
		
		self.right_button = Button(frame, text="Clockwise", fg="blue", command=self.turn('cw'))
		self.right_button.pack(side=RIGHT)

		self.left_button = Button(frame, text="Counter Clockwise", fg="green", command=self.turn('ccw'))
		self.left_button.pack(side=RIGHT)
		
	def turn(self,direction):
		global curr_position
		print(curr_position)
		if(direction == 'cw'):
				if (curr_position < 2.5):
					curr_position += 0.1
					self.set_speed(curr_position)
		elif(direction == 'ccw'):
				if (curr_position > .5):
					curr_position -= 0.1
					self.set_speed(curr_position)
		else:
			pass
		print(curr_position)
		
	def set_speed(self,pulse_time):
		global p
		valley = 20 #time between each pulse for motor servo control (msec)
		peak = pulse_time

		freq = 1/((valley+peak)*0.001)
		duty = peak/(valley+peak)*100

		p.ChangeFrequency(freq)
		p.ChangeDutyCycle(duty)
		
	def run_loop(self, root):
		print "I'm in run loop"
		root.update()
		root.after(10, self.run_loop)
		
# set up PWM and servo functions

GPIO.setmode(GPIO.BCM)

GPIO.setup(16, GPIO.OUT)

curr_position = 1.5
        
p = GPIO.PWM(16, 47)
p.start(0)

root = Tk()

app = App(root)
#root.mainloop()
#app.run_loop(root)

while True:
	print "Hooray!"
	root.update()
	time.sleep(1)


GPIO.cleanup()
quit()
