from multiprocessing.connection import Client
from Tkinter import *

class App:
	
	def __init__(self,master, connection):
		self.conn = connection
		frame = Frame(master)
		frame.pack()
		
		self.middle_button = Button(frame, text="Stop", fg="red", command=self.set_speed_stop)
		self.middle_button.pack(side=RIGHT)
		
		self.right_button = Button(frame, text="Clockwise", fg="blue", command=self.set_speed_cw)
		self.right_button.pack(side=RIGHT)

		self.left_button = Button(frame, text="Counter Clockwise", fg="green", command=self.set_speed_ccw)
		self.left_button.pack(side=RIGHT)
		
	def set_speed_ccw(self):
		self.conn.send(1.3)

	def set_speed_cw(self):
		self.conn.send(1.7)
		
	def set_speed_stop(self):
		self.conn.send(0)

address = ('localhost', 6000)
conn = Client(address)

root = Tk()

app = App(root, conn)
root.mainloop()
root.destroy()

try:
	pass
except KeyboardInterrupt:
	quit()
