from Tkinter import *

class App:

	def __init__(self, master):
		frame = Frame(master)
		frame.pack()
		self.percent = IntVar()
		#Standard button
		self.button = Button(frame, text="QUIT", fg="red", command=quit)
		self.button.pack(side=LEFT)
		#Image button
		#store images in class variable to prevent garbage cleanup
		self.gem_image = PhotoImage(file="pi.gif")
		#                           inset button            change bg when hovered over use image on button
		self.slogan = Button(frame, relief=RIDGE, bg="red", activebackground="green",   image=self.gem_image, command=self.write_slogan)
		self.slogan.pack(side=LEFT)
		#Scale
		self.slider = Scale(frame, variable =self.percent, orient=HORIZONTAL)
		self.slider.pack(side=LEFT)
		#Scale buttons
		self.downbutton = Button(frame, relief=RIDGE, text="-10", command=self.down)
		self.downbutton.pack(side=LEFT)
		self.upbutton = Button(frame, relief=RIDGE, text="+10", command=self.up)
		self.upbutton.pack(side=LEFT)

	def write_slogan(self):
		print(str(self.percent.get()))

	#set slider to it's current value +- 10
	def down(self):
		self.slider.set(self.percent.get() - 10)

	def up(self):
		self.slider.set(self.percent.get() + 10)

root = Tk()
app = App(root)
root.mainloop()
